/** \file
*/

/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE":
* tomasz.o.ostrowski <that funny sign> gmail.com wrote this file.
* As long as you retain this notice you can do whatever you want with
* this stuff. If we meet some day, and you thinkthis stuff is worth it,
* you can buy me a beer in return
* Tomasz Ostrowski
* ----------------------------------------------------------------------------
*/

#ifndef frmMainH
#define frmMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <mmsystem.h>
#include "DrawThread.h"
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <Graphics.hpp>

//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
	TPaintBox *pboxGraph;
	TLabel *lblLeft;
	TLabel *lblRight;
	TMainMenu *Menu;
	TMenuItem *miInput;
	TStatusBar *StatusBar;
	TImage *imgMouse;
	TLabel *lblZero;
	TMenuItem *Help1;
	TMenuItem *About1;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall miSelectInputClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall About1Click(TObject *Sender);

private:	// User declarations
	DrawThread*        timethread;

	HWAVEIN   hWaveIn;
	WAVEHDR*  WaveHeaders;			///< pointer to allocated table of headers
	WAVEFORMATEX  waveFormat;

	int       iBuffIdx;             ///< index of next buffer available for recording
	int       iBuffersCount;        ///< total buffer count for audio data
	int       iSamplesPerChannel;   ///< samples per channels count (in buffer)
	int       WaveBufSize;
	WAVEHDR*  SendHeader;
	bool      bRecordingStarted;    ///< is audio recording started?
	void GetWaveInDevices(void);
public:		// User declarations
	__fastcall TfrmMain(TComponent* Owner);
	void __fastcall ProcessSamples();
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
